// Override the default toggleSidebar function
function newToggleSidebar(aCommandID, forceOpen) {
  var DEFAULT_SIDEBAR_WIDTH = 200;

  // This is my aborted attempt at getting to nsIBaseWindow.setPositionAndSize.
  // For some reason, windowWatcher.getChromeForWindow is coming back null.
  //
  //alert ("getting window-watcher");
  //var windowWatcher = 
  //  Components.classes["@mozilla.org/embedcomp/window-watcher;1"]
  //            .getService(Components.interfaces.nsIWindowWatcher);
  //alert ("getting domWindow interface via " + 
  //       Components.interfaces.nsIDOMWindow);
  //var domWindow = window.QueryInterface(Components.interfaces.nsIDOMWindow);
  //alert ("getting webBrowserChrome");
  //var webBrowserChrome = windowWatcher.getChromeForWindow(domWindow);
  //alert ("getting webBrowser for " + webBrowserChrome);
  //var webBrowser = webBrowserChrome.webBrowser;
  //alert ("getting baseWindow");
  //var baseWindow = 
  //  webBrowser.QueryInterface(Components.interfaces.nsIBaseWindow);
  //alert ("setting position and size");
  //baseWindow.setPositionAndSize (0, 0, 400, 400, true);
  //alert ("done");

  var sidebarBox = document.getElementById("sidebar-box");

  // Ensure that sidebars that have never been resized have some 
  // initial dimension.
  if (sidebarBox.width == 0) {
    sidebarBox.setAttribute ("width", DEFAULT_SIDEBAR_WIDTH);
  }

  var splitterWidth = 6;
  if (!aCommandID) {
    aCommandID = sidebarBox.getAttribute("sidebarcommand");
  }
  var elt = document.getElementById(aCommandID);
  var expansionSize = splitterWidth + Number(sidebarBox.width);
  var screenX = Number(window.screenX);
  var screenY = Number(window.screenY);
  var windowWidth = Number(window.outerWidth);
  var windowHeight = Number(window.outerHeight);
  var screenWidth = Number(window.screen.width);

//  alert ("expansionSize = " + expansionSize);
//  alert ("screenX = " + screenX);
//  alert ("screenY = " + screenY);
//  alert ("windowWidth = " + windowWidth);
//  alert ("screenWidth = " + screenWidth);

  // Resize and reshape the browser to preserve the size and position 
  // of the content area.
  if (typeof(window.windowState) != 'undefined' && 
      window.windowState == STATE_NORMAL) {
    if (sidebarBox.hidden) {
      if (screenX > expansionSize) {
        window.moveBy (0 - expansionSize, 0);
      }
      else {
        window.moveTo (0, screenY);
      }
      if (windowWidth < screenWidth - expansionSize) {
        window.resizeBy (expansionSize, 0);
      }
      else {
        window.resizeTo (screenWidth, windowHeight);
      }
    }
    else if (!forceOpen && elt.getAttribute("checked") == "true") {
      window.resizeBy (0 - expansionSize, 0);
      window.moveBy (expansionSize, 0);
    }
  }

  // invoke the original toggleSidebar function
  oldToggleSidebar (aCommandID, forceOpen);
}

oldToggleSidebar = toggleSidebar;
toggleSidebar = newToggleSidebar;
